<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<title>Flow</title>
    <script src="https://unpkg.com/three@0.137.5/build/three.min.js"></script>
		<style>
			body {
i       margin: 0;
        touch-action: none;
      }
    </style>
  </head>
  <body>

    <script type="module">

      import WebGL from 'https://unpkg.com/three@0.137.5/examples/jsm/capabilities/WebGL.js';

      let camera, scene, renderer;
      let cube, sphere, torus, material;

      let count = 0, cubeCamera1, cubeCamera2, cubeRenderTarget1, cubeRenderTarget2;

      let onPointerDownPointerX, onPointerDownPointerY, onPointerDownLon, onPointerDownLat;

      let lon = 0, lat = 0;
      let phi = 0, theta = 0;

      const textureLoader = new THREE.TextureLoader();

      textureLoader.load( 'https://raw.githubusercontent.com/mrdoob/three.js/master/examples/textures/2294472375_24a3b8ef46_o.jpg', function ( texture ) {
        texture.encoding = THREE.sRGBEncoding;
        texture.mapping = THREE.EquirectangularReflectionMapping;
        init( texture );
        animate();
      } );

      function init( texture ) {

        renderer = new THREE.WebGLRenderer( { antialias: true } );
        renderer.setPixelRatio( window.devicePixelRatio );
        renderer.setSize( window.innerWidth, window.innerHeight );
        renderer.outputEncoding = THREE.sRGBEncoding;
        document.body.appendChild( renderer.domElement );

        scene = new THREE.Scene();
        scene.background = texture;

        camera = new THREE.PerspectiveCamera( 60, window.innerWidth / window.innerHeight, 1, 1000 );

        //

        cubeRenderTarget1 = new THREE.WebGLCubeRenderTarget( 256 );
        cubeCamera1 = new THREE.CubeCamera( 1, 1000, cubeRenderTarget1 );
        cubeRenderTarget2 = new THREE.WebGLCubeRenderTarget( 256 );
        cubeCamera2 = new THREE.CubeCamera( 1, 1000, cubeRenderTarget2 );

        //

        material = new THREE.MeshStandardMaterial( {
          envMap: cubeRenderTarget2.texture,
          roughness: 0.2,
          metalness: 1
        } );

        sphere = new THREE.Mesh( new THREE.IcosahedronGeometry( 10, 0 ), material );
        scene.add( sphere );

        //cube = new THREE.Mesh( new THREE.BoxGeometry( 20, 20, 20 ), material );
        //scene.add( cube );

        //torus = new THREE.Mesh( new THREE.TorusKnotGeometry( 10, 5, 128, 16 ), material );
        //scene.add( torus );

        //

        document.addEventListener( 'pointerdown', onPointerDown );
        document.addEventListener( 'wheel', onDocumentMouseWheel );

        window.addEventListener( 'resize', onWindowResized );

      }

      function onWindowResized() {

        renderer.setSize( window.innerWidth, window.innerHeight );

        camera.aspect = window.innerWidth / window.innerHeight;
        camera.updateProjectionMatrix();

      }

      function onPointerDown( event ) {

        event.preventDefault();

        onPointerDownPointerX = event.clientX;
        onPointerDownPointerY = event.clientY;

        onPointerDownLon = lon;
        onPointerDownLat = lat;

        document.addEventListener( 'pointermove', onPointerMove );
        document.addEventListener( 'pointerup', onPointerUp );

      }

      function onPointerMove( event ) {

        lon = ( event.clientX - onPointerDownPointerX ) * 0.1 + onPointerDownLon;
        lat = ( event.clientY - onPointerDownPointerY ) * 0.1 + onPointerDownLat;

      }

      function onPointerUp() {

        document.removeEventListener( 'pointermove', onPointerMove );
        document.removeEventListener( 'pointerup', onPointerUp );

      }

      function onDocumentMouseWheel( event ) {

        const fov = camera.fov + event.deltaY * 0.05;

        camera.fov = THREE.MathUtils.clamp( fov, 10, 75 );

        camera.updateProjectionMatrix();

      }

      function animate() {

        requestAnimationFrame( animate );

        const time = Date.now();

        lon += .15;

        lat = Math.max( - 85, Math.min( 85, lat ) );
        phi = THREE.MathUtils.degToRad( 90 - lat );
        theta = THREE.MathUtils.degToRad( lon );

        //cube.position.x = Math.cos( time * 0.001 ) * 30;
        //cube.position.y = Math.sin( time * 0.001 ) * 30;
        //cube.position.z = Math.sin( time * 0.001 ) * 30;

        //cube.rotation.x += 0.02;
        //cube.rotation.y += 0.03;

        //torus.position.x = Math.cos( time * 0.001 + 10 ) * 30;
        //torus.position.y = Math.sin( time * 0.001 + 10 ) * 30;
        //torus.position.z = Math.sin( time * 0.001 + 10 ) * 30;

        //torus.rotation.x += 0.02;
        //torus.rotation.y += 0.03;

        camera.position.x = 100 * Math.sin( phi ) * Math.cos( theta );
        camera.position.y = 100 * Math.cos( phi );
        camera.position.z = 100 * Math.sin( phi ) * Math.sin( theta );

        camera.lookAt( scene.position );

        // pingpong

        if ( count % 2 === 0 ) {
          cubeCamera1.update( renderer, scene );
          material.envMap = cubeRenderTarget1.texture;
        } else {
          cubeCamera2.update( renderer, scene );
          material.envMap = cubeRenderTarget2.texture;
        }

        count ++;
        render();
      }

      function render() {
        renderer.render( scene, camera );
      }

      const ws = new WebSocket("ws://192.168.1.22:8000/live");
      var zero_ct = -1;
      var zero_cl = -1;
      var zero_du = -1;
      ws.onmessage = function(event) {
        const d = JSON.parse(event.data);
        if (zero_ct == -1) {
          zero_ct = d['ct'];
        }
        if (zero_cl == -1) {
          zero_cl = d['cl'];
        }
        if (zero_du == -1) {
          zero_du = d['du'];
        }
        var x = 5 * d['ct'] / (0.0001 + zero_ct);
        var y = 5 * d['cl'] / (0.0001 + zero_cl);
        var z = 5 * d['du'] / (0.0001 + zero_du);
        sphere.scale.x = x;
        sphere.scale.y = y;
        sphere.scale.z = z;
      };

    </script>

  </body>
</html>
